package org.rcisoft.bus.jnP7sj.service.impl;


import cn.afterturn.easypoi.excel.ExcelExportUtil;
import cn.afterturn.easypoi.excel.entity.ExportParams;
import cn.afterturn.easypoi.excel.entity.enmus.ExcelType;
import cn.hutool.core.collection.CollectionUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.rcisoft.bus.jnP7sj.dao.jnP7sjRepository;
import org.rcisoft.bus.jnP7sj.dto.jnP7sjExportTemplateDto;
import org.rcisoft.bus.jnP7sj.dto.jnP7sjImportDto;
import org.rcisoft.bus.jnP7sj.dto.jnP7sjPageHandleDto;
import org.rcisoft.bus.jnP7sj.entity.jnP7sj;
import org.rcisoft.bus.jnP7sj.service.jnP7sjService;
import org.rcisoft.bus.jnsp7xtm.dto.Jnsp7xtmOptionDto;
import org.rcisoft.core.exception.CyServiceException;
import org.rcisoft.core.model.CyPageInfo;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.enums.CyImportErrCodeEnum;
import org.rcisoft.util.ExportToExcelUtil;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Service
@Transactional(readOnly = true, propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class jnP7sjServiceImpl extends ServiceImpl<jnP7sjRepository, jnP7sj> implements jnP7sjService {

    private static Lock topFourButtonLock = new ReentrantLock();

    //
    private static Lock finallyButtonLockLock = new ReentrantLock();

    @Value("${jnP7sj.batchAddPagesize}")
    private Integer batchInsertSize;

    @Value("${jnP7sj.pageQuestSize}")
    private Integer pageQuerySize;

    @Value("${jnP7sj.shema}")
    private String shema;
    @Value("${jnP7sj.importBatchAddSize}")
    private Integer importBatchAddSize;

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel persist(jnP7sj jnP7sj) {
        int line = baseMapper.insert(jnP7sj);
        log.debug(CyUserUtil.getAuthenUsername() + "新增了ID为" +
                jnP7sj.getBusinessId() + "的信息");
        return new CyPersistModel(line);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel remove(jnP7sj jnP7sj) {
        int line = baseMapper.realDelete(jnP7sj);
        log.debug(CyUserUtil.getAuthenUsername() + "删除了ID为" +
                jnP7sj.getBusinessId() + "的信息");
        return new CyPersistModel(line);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel removeLogical(jnP7sj jnP7sj) {
        jnP7sj.setDeleted();
        int line = baseMapper.deleteById(jnP7sj);
        log.debug(CyUserUtil.getAuthenUsername() + "逻辑删除了ID为" +
                jnP7sj.getBusinessId() + "的信息");
        return new CyPersistModel(line);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel merge(jnP7sj jnP7sj) {
        int line = baseMapper.updateById(jnP7sj);
        log.debug(CyUserUtil.getAuthenUsername() + "修改了ID为" + jnP7sj.getBusinessId() + "的信息");
        return new CyPersistModel(line);
    }

    @Override
    public jnP7sj findById(int id) {
        return baseMapper.selectById(id);
    }

    @Override
    public IPage<jnP7sj> findAllByPagination(CyPageInfo<jnP7sj> paginationUtility, jnP7sj jnP7sj) {
        return baseMapper.queryjnP7sjPaged(paginationUtility, jnP7sj);

    }
    @Override
    public Jnsp7xtmOptionDto getMonth() {
        Jnsp7xtmOptionDto jnsp7xtmOptionDto = new Jnsp7xtmOptionDto();
        List<String> monthList = baseMapper.getMonthList();
        jnsp7xtmOptionDto.setLabel("month");
        jnsp7xtmOptionDto.setPullDownList(monthList);
        return jnsp7xtmOptionDto;
    }
    @Override
    public List<jnP7sj> findAll(jnP7sj jnP7sj) {
        return baseMapper.queryjnP7sj(jnP7sj);
    }

    @Override
    public List<jnP7sj> export(jnP7sj jnP7sj) {
        List<jnP7sj> jnP7sjList = baseMapper.queryjnP7sj(jnP7sj);
        return jnP7sjList;
    }


    @Override
    public void jnP7sjDownEmptyTemplate(jnP7sjPageHandleDto jnsp7xtmDqsjPageHandleDto, HttpServletResponse response) {
        // 导出空模板
        OutputStream outputStream = null;
        Workbook workbook = null;
        try {
            response.setCharacterEncoding("UTF-8");
            response.setHeader("content-Type", "application/vnd.ms-excel");
            response.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode("试题数据信息.xlsx", "UTF-8"));
            ExportParams exportParams = new ExportParams();
            exportParams.setType(ExcelType.XSSF);
            List<jnP7sjExportTemplateDto> exportList = new ArrayList<>();
            workbook = ExcelExportUtil.exportExcel(exportParams, jnP7sjExportTemplateDto.class, exportList);
            Sheet sheet = workbook.getSheetAt(0);
            String[] termList = new String[]{"L", "c"};
            ExportToExcelUtil.XSSFSetDropDownAndHidden(termList, workbook, sheet, 1, 100000, 0, 0);
            outputStream = response.getOutputStream();
            workbook.write(outputStream);
        } catch (IOException e) {
            throw new CyServiceException(e.getMessage());
        } finally {
            try {
                if (outputStream != null) {
                    outputStream.close();
                }
            } catch (IOException var11) {
                log.info("context:" + var11);
            }
        }

    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT)
    @Override
    public jnP7sjImportDto jnP7sjImportDtoExcel(MultipartFile file) {
        jnP7sjImportDto jnP7sjImportDto = new jnP7sjImportDto();
        try {
            if (finallyButtonLockLock.tryLock(1000, TimeUnit.MILLISECONDS)) {
                try {
                    // 要添加的数据行数据
                    int rows = 0;
                    // 要添加的list
                    List<jnP7sj> jnP7sjList = new ArrayList<>();
                    List<jnP7sjExportTemplateDto> dataList = ExportToExcelUtil.importExcelNotTitle(file, 1, 1, jnP7sjExportTemplateDto.class);
                    if (CollectionUtil.isEmpty(dataList)) {
                        throw new CyServiceException(CyImportErrCodeEnum.IMPORT_ERR.getCode(), "导入模板为空");
                    }
                    for (int i = 0; i < dataList.size(); i++) {
                        /**
                         * 1.校验 month和cc和pn 必填
                         * **/
                        if (StringUtils.isNotBlank(dataList.get(i).getMonth()) && StringUtils.isNotBlank(dataList.get(i).getCc()) && StringUtils.isNotBlank(dataList.get(i).getPn())) {
                            /**
                             * 2.校验 amt,rate,up,qty,fc,po 格式是数据
                             * **/
                            if ((dataList.get(i).getMonth().length() != 6 && this.isValidDate(dataList.get(i).getMonth())))
                                throw new CyServiceException(CyImportErrCodeEnum.IMPORT_ERR.getCode(), "第" + (i + 1) + "行month格式不对");
                            if (!StringUtils.isEmpty(dataList.get(i).getQty())) {
                                if (!isValidIntegerOrLessThanNDecimal(dataList.get(i).getQty(), 2))
                                    throw new CyServiceException(CyImportErrCodeEnum.IMPORT_ERR.getCode(), "第" + (i + 1) + "行qty格式不对");
                            }
                            if (!StringUtils.isEmpty(dataList.get(i).getFc())) {
                                if (!isValidIntegerOrLessThanNDecimal(dataList.get(i).getFc(), 2))
                                    throw new CyServiceException(CyImportErrCodeEnum.IMPORT_ERR.getCode(), "第" + (i + 1) + "行fc格式不对");
                            }
                            if (!StringUtils.isEmpty(dataList.get(i).getPo())) {
                                if (!isValidIntegerOrLessThanNDecimal(dataList.get(i).getPo(), 2))
                                    throw new CyServiceException(CyImportErrCodeEnum.IMPORT_ERR.getCode(), "第" + (i + 1) + "行po格式不对");
                            }
                            /**
                             * 3.转换jnsp7xtmDqsj
                             * **/
                            jnP7sj jnP7sj = new jnP7sj();
                            if (StringUtils.isNotEmpty(dataList.get(i).getCc())) {
                                List<jnP7sj> dqsjList = baseMapper.queryCustomer(dataList.get(i).getCc());
                                if (CollectionUtil.isNotEmpty(dqsjList)) {
                                    jnP7sj = dqsjList.get(0);
                                }
                            }

                            jnP7sj finallyjnP7sj = jnP7sj.generatejnP7sj(dataList.get(i), jnP7sj);
                            if (StringUtils.isNotEmpty(dataList.get(i).getPn())) {
                                List<String> list = baseMapper.querySypnByPn(dataList.get(i).getPn());
                                if (CollectionUtil.isNotEmpty(list)) {
                                    finallyjnP7sj.setSypn(list.get(0));
                                }
                            }
                            jnP7sjList.add(finallyjnP7sj);
                            rows = rows + 1;
                            if (jnP7sjList.size() == importBatchAddSize) {
                                this.importBatchAddList(jnP7sjList);
                                jnP7sjList.clear();
                            }
                        }
                    }
                    if (CollectionUtil.isNotEmpty(jnP7sjList)) {
                        baseMapper.batchAddjnP7sj(jnP7sjList);
                    }
                    jnP7sjImportDto.setTotal(dataList.size());
                    jnP7sjImportDto.setRows(rows);
                    return jnP7sjImportDto;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new CyServiceException(CyImportErrCodeEnum.IMPORT_ERR.getCode(), e.getMessage());
                } finally {
                    finallyButtonLockLock.unlock();
                }
            } else {
                throw new CyServiceException(501, "该功能使用频繁,请稍后重试");
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        return jnP7sjImportDto;
    }

    private void importBatchAddList(List<jnP7sj> list) {
        baseMapper.batchAddjnP7sj(list);
    }

    /**
     * 校验月份的格式是否正确
     **/
    public boolean isValidDate(String str) {
        String pattern = "^\\d{4}\\d{2}$"; // 前四位是年，后两位是月份
        Pattern r = Pattern.compile(pattern);
        Matcher m = r.matcher(str);
        return m.matches();
    }

    public static boolean isValidIntegerOrLessThanNDecimal(String str, int n) {
        try {
            BigDecimal bd = new BigDecimal(str);
            if (bd.scale() <= n) {
                return true;
            }
        } catch (NumberFormatException e) {
        }
        return false;
    }
}
